/////////// STREAM BUFFERIZATION //////////////
unsigned char fifo1_empty,fifo2_empty;//FIFO buffers status flags
unsigned char fifo_number;//buffer for output, 0=FIFO1; 1=FIFO2
unsigned char file_finished;//0=currently playing; 1=file finished
unsigned int point_counter;//  ,     FIFO 

#define FIFO_LEN 318//     
///    ,    ///

unsigned int index;//index of currently playing buffer

unsigned char FIFO1[FIFO_LEN],FIFO2[FIFO_LEN];//FIFO  buffers

///    (FIFO1  FIFO2)///
void load_fifo(unsigned char b_number)
{
        unsigned int i=0;
        struct FRAME_RESULT frame;
        
        if(b_number)//FIFO2
                {
                while((i<(FIFO_LEN-1))&&(!file_finished))//  ,          
                        {
                        if(++point_counter>total_points)//        , 
                                { 
                                frame=*load_header();//   
                                if(!(frame.total_points && frame.frame_status))//  =0   
                                  { 
                                  file_finished=1;// 
                                  goto end_fifo2;//   
                                  };
                                point_counter=1;//    
                                total_points=frame.total_points;//      
                                };
                        load_point();//    
                        FIFO2[i]=x;//   
                        FIFO2[++i]=y;
                        ++i;//FIFO2[++i]=0;//blanking//      
                        ++i;//       
                        };
                end_fifo2:
                fifo2_empty=0;//2-          
                }
        else//FIFO1
                {
                while((i<(FIFO_LEN-1))&&(!file_finished))
                        {
                        if(++point_counter>total_points)
                                { 
                                frame=*load_header();
                                if(!(frame.total_points && frame.frame_status))
                                  { 
                                  file_finished=1;
                                  goto end_fifo1;
                                  };
                                point_counter=1;
                                total_points=frame.total_points;
                                };
                        load_point();
                        FIFO1[i]=x;
                        FIFO1[++i]=y;
                        ++i;//FIFO1[++i]=0;//blanking
                        ++i;
                        };
                end_fifo1:
                fifo1_empty=0;
                };
} 

///// Start to play opened file //////
void play_file(void)
{
        fifo_number=0;//FIFO1
        index=0;//FIFO index -     
        fifo1_empty=1;//  
        fifo2_empty=1;//FIFO2 is empty
        file_finished=0;//file is not finished, start of file
        point_counter=0;//     
        while(!file_finished)//     
                {
                load_fifo(0);// FIFO1
                while(!(fifo2_empty | file_finished));//       
	// .. fifo2_empty=1,        - //
                fifo_number=0;//switch FIFO1 for output
                load_fifo(1);// FIFO2
                enable_TIM1_int();//   ,     ->   FIFO1     TIM1_OVF
                while(!(fifo1_empty | file_finished));//wait when FIFO1 will be empty
                fifo_number=1;//switch FIFO2 for output
                };
        disable_TIM1_int();//  ->  FIFO   
}

///// Read value from FIFO buffer /////
void read_fifo(void)
{                
        if(fifo_number)//FIFO2=1
                {
                OCR0A=FIFO2[index];//     
                OCR0B=FIFO2[++index];
                ++index;//increment for blanking byte
                if((++index)>(FIFO_LEN-1))//reached top of FIFO buffer
                        {
                        index=0;//    
                        fifo2_empty=1;//FIFO2 
                        if(fifo1_empty) disable_TIM1_int();// FIFO1  FIFO2 ,       
                        };
                }
        else//FIFO1=0
                {
                OCR0A=FIFO1[index];
                OCR0B=FIFO1[++index];
                ++index;//blanking;
                if(++index>(FIFO_LEN-1))//reached top of FIFO buffer
                        {
                        index=0;
                        fifo1_empty=1;
                        if(fifo2_empty) disable_TIM1_int();
                        };
                };
}